#include "eef_library.h"
#include "cgul/log_to_file/log_to_file.h"

int main (int argc, char* argv[]){
  aos_context_t* context = NULL;
  aos_attribute_t* attribute = NULL;

  cgul_openlog("/tmp/mini_aos_test");
  cgul_set_ident(BINARY_NAME);
  cgul_set_log_options(CGUL_SYSLOG | CGUL_LOGFILE | CGUL_STDERR);
#if ENABLE_DEBUG
  cgul_set_log_options(cgul_get_log_options() | CGUL_STDDEBUG);
#endif

  EEF_log = cgul_log;
  AOS_Init();

  rewindContexts(NULL);
  while((context = getNextContext(ANY, NULL))){
    printf("Got context: %p\n", (void*) context); 
  }

  context = createContext(NONE);
  printf("Made context: %p\n", (void*) context);

  addContext(context);
  printf("Added context: %p\n", (void*) context);

  if((attribute = createAttribute())){
    printf("Created attribute: %p\n", (void*) attribute);
    setAttributeId(attribute, "Bla");
    setAttributeValue(attribute, "Foo", 4);
    addAttribute(context, attribute);
    printf("Added attribute %p to context %p\n", (void*) attribute, (void*) context);
  }


  aos_dump_argslist();
  
  AOS_Term();
  EEF_log(LOG_NOTICE, "Mini AOS test terminated!\n");
  cgul_closelog();

}
